<script setup lang="ts">
import SystemInfoTable from '../SystemInfoTable/SystemInfoTable.vue';
import { ref, toRefs } from 'vue';
import type { PropType } from 'vue';
import { IOtherTab, ISDCard } from '../../product.datatype';
import { getBoard } from '../../service/system.service';
import { isOtherEmptyProperty } from '../../utils/system.util';

const props = defineProps({
  data: {
    type: Object as PropType<IOtherTab>,
    required: true,
    default: () => {
      return {};
    },
  },
});
const tableId = 'sdTable';
const { data } = toRefs(props);
const boardData: IOtherTab = data?.value;
const boardTableData = ref([] as any);
const boardShow = ref(false);

if (boardData.currentNumber && boardData.currentNumber > 0) {
  getBoard(boardData.detailLink).then((res: any) => {
    if (res.data && res.data.length > 0) {
      res.data.forEach((borad: any) => {
        const d = parseData(borad);
        if (d) {
          boardTableData.value.push(d);
        }
      });
    }
    boardShow.value = true; // 异步请求，等请求结束才能显示
  });
} else {
  boardShow.value = true; // 为了显示表头
}

function parseData(board: any): ISDCard {
  let capacityBytes = null;
  if (board.CapacityBytes === 0 || board.CapacityBytes) {
    capacityBytes = board.CapacityBytes;
    capacityBytes = capacityBytes / 1024 / 1024;
    capacityBytes = capacityBytes.toFixed(0);
  } else {
    capacityBytes = null;
  }
  return {
    id: isOtherEmptyProperty(board.Id) ? board.Id.substring(15) : 0,
    manufacturer: isOtherEmptyProperty(board.Manufacturer) || ' ',
    serialNumber: isOtherEmptyProperty(board.SerialNumber) || ' ',
    capacity: capacityBytes,
  };
}

const columns = [
  {
    title: 'OTHER_SLOT_POSITION',
    show: true,
    content: 'id',
  },
  {
    title: 'COMMON_MANUFACTURER',
    show: true,
    content: 'manufacturer',
  },
  {
    title: 'COMMON_SERIALNUMBER',
    show: true,
    content: 'serialNumber',
  },
  {
    title: 'COMMON_CAPACITY',
    show: true,
    content: 'capacity',
  },
];
</script>

<template>
  <SystemInfoTable
    v-if="boardShow"
    :id="tableId"
    :data="boardTableData"
    :columns="columns"
    :num="boardData.maxNumber"
  />
</template>

<style lang="scss" scoped></style>
